###############################################################################
# StopForumSpamLog.pm                                                         #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.6.1                                                  #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2014 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
our $VERSION = '2.6.12';

$stopforumspamlogpmver = 'YaBB 2.6.12 $Revision: 0.3 $';

if ( $action eq 'detailedversion' ) { return 1; }

LoadLanguage('Mods/StopForumSpam');

sub StopForumSpamLog {

    is_admin_or_gmod();

    if ( -e "$vardir/Mods/stopforumspam.log" ) {
        fopen( SFSLOG, "$vardir/Mods/stopforumspam.log" );
        @sfs_entries = <SFSLOG>;
        fclose(SFSLOG);
        @sfs_entries = reverse @sfs_entries;
    }

    if ( @sfs_entries > 0 ) {
        $sfs_logcount = @sfs_entries;
        my $newstart = $INFO{'newstart'} || 0;

        $postdisplaynum = 8;
        $max            = $sfs_logcount;
        $tmpa           = 1;
        if ( $newstart >= ( ( $postdisplaynum - 1 ) * 25 ) ) {
            $startpage = $newstart - ( ( $postdisplaynum - 1 ) * 25 );
            $tmpa = int( $startpage / 25 ) + 1;
        }
        if ( $max >= $newstart + ( $postdisplaynum * 25 ) ) {
            $endpage = $newstart + ( $postdisplaynum * 25 );
        }
        else { $endpage = $max }
        if ( $startpage > 0 ) {
            $pageindex =
qq~<a href="$adminurl?action=$action;newstart=0" class="norm">1</a>&nbsp;...&nbsp;~;
        }
        if ( $startpage == 25 ) {
            $pageindex =
qq~<a href="$adminurl?action=$action;newstart=0" class="norm">1</a>&nbsp;~;
        }
        foreach my $counter ( $startpage .. ( $endpage - 1 ) ) {
            if ( $counter % 25 == 0 ) {
                $pageindex .=
                  $newstart == $counter
                  ? qq~<b>$tmpa</b>&nbsp;~
                  : qq~<a href="$adminurl?action=$action;newstart=$counter" class="norm">$tmpa</a>&nbsp;~;
                $tmpa++;
            }
        }
        $lastpn  = int( $logcount / 25 ) + 1;
        $lastptn = ( $lastpn - 1 ) * 25;
        if ( $endpage < $max - (25) ) { $pageindexadd = q~...&nbsp;~; }
        if ( $endpage != $max ) {
            $pageindexadd .=
qq~<a href="$adminurl?action=$action;newstart=$lastptn">$lastpn</a>~;
        }
        $pageindex .= $pageindexadd;

        $pageindex = qq~<tr>
                <td class="windowbg" colspan="5"><span class="small" style="float: left;">$admin_txt{'139'}: $pageindex</span></td>
            </tr>~;

        $numbegin = ( $newstart + 1 );
        $numend   = ( $newstart + 25 );
        if   ( $numend > $logcount ) { $numend  = $logcount; }
        if   ( $logcount == 0 )      { $numshow = q{}; }
        else                         { $numshow = qq~($numbegin - $numend)~; }

        @sfs_entries = splice @sfs_entries, $newstart, 25;

        foreach my $sfs_entry (@sfs_entries) {
            chomp $sfs_entry;
            my (
                $sfs_log_time,  $sfs_log_status, $sfs_log_username,
                $sfs_log_email, $sfs_log_ip
            ) = split /[|]/xsm, $sfs_entry;
            $sfs_log_time = timeformat($sfs_log_time);
            if ( $sfs_log_status eq 'ok' ) {
                $sfs_log_status =
                  qq~<span style="color: #008000;">$sfs_log_txt{'ok'}</span>~;
            }
            elsif ( $sfs_log_status eq 'blocked' ) {
                $sfs_log_status =
qq~<span style="color: #0000FF;">$sfs_log_txt{'blocked'}</span>~;
            }
            else {
                $sfs_log_status =
qq~<span style="color: #FF0000;">$sfs_log_txt{'error'}</span> $sfs_log_status~;
            }
            $sfs_loglist .= qq~<tr>
            <td class="windowbg2">$sfs_log_status</td>
            <td class="windowbg">$sfs_log_time</td>
            <td class="windowbg2">$sfs_log_username</td>
            <td class="windowbg">$sfs_log_email</td>
            <td class="windowbg2">$sfs_log_ip</td>
        </tr>~;
        }
    }
    else {
        $sfs_loglist = qq~<tr>
    <td class="windowbg2 center" colspan="5">$sfs_log_txt{'no_entries'}</td>
        </tr>~;
    }

    $yymain .= qq~
<form action="$adminurl?action=clearspamlog" method="post">
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <colgroup>
                <col style="width:12%" />
                <col style="width:22%" span="4" />
            </colgroup>
            <tr>
                <th class="titlebg" colspan="5"><img src="$yyhtml_root/ModImages/sfs.png" alt="" /> <b>$admintxt{'a8_sub6'}</b></th>
            </tr><tr>
                <td class="windowbg2" colspan="5">$sfs_log_txt{'description'}</td>
            </tr>
$pageindex
            <tr style="font-weight: bold;">
                <td class="catbg">$sfs_log_txt{'status'}</td>
                <td class="catbg">$sfs_log_txt{'date'}</td>
                <td class="catbg">$sfs_log_txt{'username'}</td>
                <td class="catbg">$sfs_log_txt{'email'}</td>
                <td class="catbg">$sfs_log_txt{'ip'}</td>
            </tr>
$sfs_loglist
$pageindex
        </table>
    </div>
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell">
            <tr>
                <th class="titlebg">$admin_img{'prefimg'} $admin_txt{'725e'}</th>
            </tr><tr>
                <td class="catbg center"><input type="submit" value="$sfs_log_txt{'clear'}" onclick="return confirm('$sfs_log_txt{'clear_confirm'}');" class="button" /></td>
            </tr>
        </table>
    </div>
</form>
~;

    $yytitle     = $admintxt{'a8_label6'};
    $action_area = 'stopforumspam_log';
    AdminTemplate();

    return;
}

sub ClearSpamLog {

    is_admin_or_gmod();

    if ( -e "$vardir/Mods/stopforumspam.log" ) {
        unlink "$vardir/Mods/stopforumspam.log";
    }

    $yySetLocation = qq~$adminurl?action=stopforumspam_log~;
    redirectexit();

    return;

}

1;
